Index: /trunk/src/org/expeditee/gui/Frame.java
===================================================================
--- /trunk/src/org/expeditee/gui/Frame.java	(revision 1101)
+++ /trunk/src/org/expeditee/gui/Frame.java	(revision 1102)
@@ -1266,11 +1304,9 @@
 
 			// If its the title index will be 0
-			if (index < 0)
-				index = 0;
+			if (index < 0) index = 0;
 
 			for (int i = index; i < toCheck.size(); i++) {
 				Text item = toCheck.get(i);
-				if (FrameUtils.inSameColumn(from, item))
-					column.add(item);
+				if (FrameUtils.inSameColumn(from, item)) column.add(item);
 			}
 		}
@@ -1289,39 +1325,44 @@
 	 *             If overlay is null.
 	 */
-	protected boolean addVector(Vector toAdd) {
+	protected boolean addVector(Vector toAdd)
+	{
 		// make sure we dont add this frame as an overlay of itself
-		if (toAdd.Frame == this)
-			return false;
+		if (toAdd.Frame == this) return false;
+		
 		_vectors.add(toAdd);
+		
 		// Items must be notified that they have been added or removed from this
 		// frame via the vector...
 		int maxX = 0;
 		int maxY = 0;
+		
 		HighlightMode mode = toAdd.Source.getHighlightMode();
-		if (mode != HighlightMode.None)
-			mode = HighlightMode.Connected;
-		Color highlightColor = toAdd.Source.getHighlightColor();
+		if (mode != HighlightMode.None) mode = HighlightMode.Connected;
+		
+		Colour highlightColor = toAdd.Source.getHighlightColor();
+		
 		for (Item i : ItemUtils.CopyItems(toAdd.Frame.getVectorItems(), toAdd)) {
-			i.onParentStateChanged(new ItemParentStateChangedEvent(this,
-					ItemParentStateChangedEvent.EVENT_TYPE_ADDED_VIA_OVERLAY,
-					toAdd.permission));
+			i.onParentStateChanged(new ItemParentStateChangedEvent(this, ItemParentStateChangedEvent.EVENT_TYPE_ADDED_VIA_OVERLAY, toAdd.permission));
 			i.setEditTarget(toAdd.Source);
-			i.setHighlightMode(mode, highlightColor);
+			i.setHighlightModeAndColour(mode, highlightColor);
 			_vectorItems.add(i);
 			i.invalidateAll();
 			i.invalidateFill();
+			
 			// Get the right most x and bottom most y pos
 			int itemRight = i.getX() + i.getBoundsWidth();
-			if (itemRight > maxX)
-				maxX = itemRight;
+			if (itemRight > maxX) maxX = itemRight;
+			
 			int itemBottom = i.getY() + i.getBoundsHeight();
-			if (itemBottom > maxY)
-				maxY = itemBottom;
-		}
+			if (itemBottom > maxY) maxY = itemBottom;
+		}
+		
 		toAdd.setSize(maxX, maxY);
+		
 		return true;
 	}
 
-	public Collection<Vector> getVectors() {
+	public Collection<Vector> getVectors()
+	{
 		Collection<Vector> l = new LinkedList<Vector>();
 		l.addAll(_vectors);
@@ -1329,12 +1370,14 @@
 	}
 
-	public Collection<Overlay> getOverlays() {
+	public Collection<Overlay> getOverlays()
+	{
 		return new LinkedList<Overlay>(_overlays.keySet());
 	}
 
 	/**
-	 * @return All vectosr seen by this frame (including its vector's vectors).
-	 */
-	public List<Vector> getVectorsDeep() {
+	 * @return All vectors seen by this frame (including its vector's vectors).
+	 */
+	public List<Vector> getVectorsDeep()
+	{
 		List<Vector> l = new LinkedList<Vector>();
 		getVectorsDeep(l, this, new LinkedList<Frame>());
@@ -1342,15 +1385,13 @@
 	}
 
-	private boolean getVectorsDeep(List<Vector> vectors, Frame vector,
-			List<Frame> seenVectors) {
-
-		if (seenVectors.contains(vector))
-			return false;
+	private boolean getVectorsDeep(List<Vector> vectors, Frame vector, List<Frame> seenVectors)
+	{
+		if (seenVectors.contains(vector)) return false;
 
 		seenVectors.add(vector);
 
-		for (Vector o : vector.getVectors()) {
-			if (getVectorsDeep(vectors, o.Frame, seenVectors)) {
-				vectors.add(o);
+		for (Vector v : vector.getVectors()) {
+			if (getVectorsDeep(vectors, v.Frame, seenVectors)) {
+				vectors.add(v);
 			}
 		}
@@ -1359,20 +1400,46 @@
 	}
 
-	// private boolean getOverlaysDeep(List<Overlay> overlays, Frame overlay,
-	// List<Frame> seenOverlays) {
-	//
-	// if (seenOverlays.contains(overlay))
-	// return false;
-	//
-	// seenOverlays.add(overlay);
-	//
-	// for (Overlay o : overlay.getOverlays()) {
-	// if (getOverlaysDeep(overlays, o.Frame, seenOverlays)) {
-	// overlays.add(o);
-	// }
-	// }
-	//
-	// return true;
-	// }
+	public List<Overlay> getOverlaysDeep()
+	{
+		List<Overlay> ret = new LinkedList<Overlay>();
+		
+		getOverlaysDeep(ret, new LinkedList<Frame>());
+		
+		return ret;
+	}
+	
+	private boolean getOverlaysDeep(List<Overlay> overlays, List<Frame> seenOverlays)
+	{
+		if (seenOverlays.contains(this)) return false;
+		
+		seenOverlays.add(this);
+		
+		for (Overlay o : this.getOverlays()) {
+			if (o.Frame.getOverlaysDeep(overlays, seenOverlays)) {
+				overlays.add(o);
+			}
+		}
+		return true;
+	}
+	
+	/**
+	 * Recursive function similar to AddAllOverlayItems.
+	 * 
+	 * @param widgets
+	 *            The collection the widgets will be added to
+	 * @param overlay
+	 *            An "overlay" frame - this initially will be the parent frame
+	 * @param seenOverlays
+	 *            Used for state in the recursion stack. Pass as an empty
+	 *            (non-null) list.
+	 */
+	public List<Widget> getAllOverlayWidgets()
+	{
+		List<Widget> widgets = new LinkedList<Widget>();
+		
+		for (Overlay o : getOverlaysDeep()) widgets.addAll(o.Frame.getInteractiveWidgets());
+		
+		return widgets;
+	}
 
 	/**
@@ -1381,21 +1448,19 @@
 	 * @param item
 	 *            The item - must not be null.
-	 * @return The overlay that contains the itm. Null if no overlay owns the
+	 * @return The overlay that contains the item. Null if no overlay owns the
 	 *         item.
 	 */
-	public Overlay getOverlayOwner(Item item) {
-		if (item == null)
-			throw new NullPointerException("item");
+	public Overlay getOverlayOwner(Item item)
+	{
+		if (item == null) throw new NullPointerException("item");
 
 		for (Overlay l : getOverlays()) {
-			if (item.getParent() == l.Frame)
-				return l;
+			if (item.getParent() == l.Frame) return l;
 		}
 
 		// TODO return the correct vector... not just the first vector matching
-		// the vectorFrame
+		// the vector frame
 		for (Vector v : getVectors()) {
-			if (item.getParent() == v.Frame)
-				return v;
+			if (item.getParent() == v.Frame) return v;
 		}
 
@@ -1403,5 +1468,6 @@
 	}
 
-	public void clearVectors() {
+	public void clearVectors()
+	{
 		_vectors.clear();
 
@@ -1414,7 +1480,8 @@
 	}
 
-	protected boolean removeVector(Vector toRemove) {
-		if (!_vectors.remove(toRemove))
-			return false;
+	protected boolean removeVector(Vector toRemove)
+	{
+		if (!_vectors.remove(toRemove)) return false;
+		
 		for (Item i : toRemove.Frame.getVectorItems()) {
 			i.invalidateAll();
@@ -1426,12 +1493,13 @@
 
 		}
+		
 		return true;
 	}
 
-	public void clearOverlays() {
+	public void clearOverlays()
+	{
 		for (Overlay o : _overlays.keySet()) {
 			for (Item i : o.Frame.getItems()) {
-				i
-						.onParentStateChanged(new ItemParentStateChangedEvent(
+				i.onParentStateChanged(new ItemParentStateChangedEvent(
 								this,
 								ItemParentStateChangedEvent.EVENT_TYPE_REMOVED_VIA_OVERLAY,
@@ -1444,23 +1512,27 @@
 	}
 
-	protected boolean removeOverlay(Frame f) {
+	protected boolean removeOverlay(Frame f)
+	{
 		for (Overlay o : _overlays.keySet()) {
 			if (o.Frame == f) {
 				_overlays.remove(o);
+				
 				for (Item i : f.getItems()) {
 					_overlayItems.remove(i);
-					i
-							.onParentStateChanged(new ItemParentStateChangedEvent(
+					i.onParentStateChanged(new ItemParentStateChangedEvent(
 									this,
 									ItemParentStateChangedEvent.EVENT_TYPE_REMOVED_VIA_OVERLAY,
 									o.permission));
 				}
+				
 				return true;
 			}
 		}
+		
 		return false;
 	}
 
-	public void addAllVectors(List<Vector> vectors) {
+	public void addAllVectors(List<Vector> vectors)
+	{
 		for (Vector v : vectors) {
 			addVector(v);
@@ -1468,5 +1540,6 @@
 	}
 
-	public void addAllOverlays(Collection<Overlay> overlays) {
+	public void addAllOverlays(Collection<Overlay> overlays)
+	{
 		for (Overlay o : overlays) {
 			addOverlay(o);
@@ -1474,31 +1547,29 @@
 	}
 
-	protected boolean addOverlay(Overlay toAdd) {
+	protected boolean addOverlay(Overlay toAdd)
+	{
 		// make sure we dont add this frame as an overlay of itself
-		if (toAdd.Frame == this)
-			return false;
+		if (toAdd.Frame == this) return false;
+		
 		// Dont add the overlay if there is already one for this frame
-		if (_overlays.values().contains(toAdd.Frame))
-			return false;
+		if (_overlays.values().contains(toAdd.Frame)) return false;
+		
 		// Add the overlay to the map of overlays on this frame
 		_overlays.put(toAdd, toAdd.Frame);
+		
 		// Add all the overlays from the overlay frame to this frame
-		for (Overlay o : toAdd.Frame.getOverlays())
-			addOverlay(o);
+		// TODO: Can this cause a recursion loop? If A and B are overlays of each other? cts16
+		for (Overlay o : toAdd.Frame.getOverlays()) addOverlay(o);
 
 		// Add all the vectors from the overlay frame to this frame
-		for (Vector v : toAdd.Frame.getVectors())
-			addVector(v);
+		for (Vector v : toAdd.Frame.getVectors()) addVector(v);
 
 		// Now add the items for this overlay
-		UserAppliedPermission permission = UserAppliedPermission.min(toAdd.Frame.getUserAppliedPermission(),toAdd.permission);
+		UserAppliedPermission permission = UserAppliedPermission.min(toAdd.Frame.getUserAppliedPermission(), toAdd.permission);
 
 		// Items must be notified that they have been added or removed from this
 		// frame via the overlay...
 		for (Item i : toAdd.Frame.getVisibleItems()) {
-			i.onParentStateChanged(new ItemParentStateChangedEvent(this,
-					ItemParentStateChangedEvent.EVENT_TYPE_ADDED_VIA_OVERLAY,
-					permission));
-			// i.setPermission(permission);
+			i.onParentStateChanged(new ItemParentStateChangedEvent(this, ItemParentStateChangedEvent.EVENT_TYPE_ADDED_VIA_OVERLAY, permission));
 			_overlayItems.add(i);
 		}
@@ -1508,8 +1579,8 @@
 
 	@Override
-	public boolean equals(Object o) {
+	public boolean equals(Object o)
+	{
 		if (o instanceof String) {
-			return (String.CASE_INSENSITIVE_ORDER
-					.compare((String) o, getName()) == 0);
+			return (String.CASE_INSENSITIVE_ORDER.compare((String) o, getName()) == 0);
 		}
 
@@ -1526,7 +1597,7 @@
 	 * @param toMergeWith
 	 */
-	private void merge(Frame toMergeWith) {
-		if (toMergeWith == null)
-			return;
+	private void merge(Frame toMergeWith)
+	{
+		if (toMergeWith == null) return;
 
 		List<Item> copies = ItemUtils.CopyItems(toMergeWith.getItems());
@@ -1548,16 +1619,16 @@
 	 * @return the items that cant be merged
 	 */
-	public List<Item> merge(List<Item> toMerge) {
+	public List<Item> merge(List<Item> toMerge)
+	{
 		ArrayList<Item> remain = new ArrayList<Item>(0);
 
 		for (Item i : toMerge) {
-			if (!(i instanceof Text))
+			if (!(i instanceof Text)) {
 				remain.add(i);
-			else {
+			} else {
 				if (!AttributeUtils.setAttribute(this, (Text) i)) {
-					if (i.getLink() != null)
+					if (i.getLink() != null) {
 						merge(FrameIO.LoadFrame(i.getAbsoluteLink()));
-					else if (FrameIO
-							.isValidFrameName(((Text) i).getFirstLine())) {
+					} else if (FrameIO.isValidFrameName(((Text) i).getFirstLine())) {
 						// If we get hear we are merging frames
 						merge(FrameIO.LoadFrame(((Text) i).getFirstLine()));
@@ -1574,17 +1645,21 @@
 	 * items are added to the backup-stack.
 	 */
-	public void clear(boolean keepAnnotations) {
+	public void clear(boolean keepAnnotations)
+	{
 		List<Item> newBody = new ArrayList<Item>(0);
+		
 		Item title = getTitleItem();
+		
 		if (title != null) {
 			newBody.add(title);
 			_body.remove(title);
 		}
+		
 		if (keepAnnotations) {
 			for (Item i : _body) {
-				if (i.isAnnotation())
-					newBody.add(i);
-			}
-		}
+				if (i.isAnnotation()) newBody.add(i);
+			}
+		}
+		
 		_body.removeAll(newBody);
 		addToUndoDelete(_body);
@@ -1592,6 +1667,5 @@
 		change();
 
-		if (!keepAnnotations && _annotations != null)
-			_annotations.clear();
+		if (!keepAnnotations && _annotations != null) _annotations.clear();
 	}
 
@@ -1602,5 +1676,6 @@
 	 * @return
 	 */
-	public Text createNewText(String text) {
+	public Text createNewText(String text)
+	{
 		Text t = createBlankText(text);
 		t.setText(text);
@@ -1615,15 +1690,18 @@
 	 * @return The newly created Text Item
 	 */
-	public Text createBlankText(String templateType) {
+	public Text createBlankText(String templateType)
+	{
 		SessionStats.CreatedText();
 		Text t;
-		if (templateType.length() == 0)
+		
+		if (templateType.length() == 0) {
 			t = getItemTemplate().copy();
-		else
+		} else {
 			t = getItemTemplate(templateType.charAt(0));
-
+		}
+		
 		// reset attributes
 		t.setID(getNextItemID());
-		t.setPosition(DisplayIO.getMouseX(), FrameMouseActions.getY());
+		t.setPosition(DisplayController.getMousePosition());
 		t.setText("");
 		t.setParent(this);
@@ -1648,14 +1726,12 @@
 	}
 
-	public Item createDot() {
-		Item dot = new Dot(DisplayIO.getMouseX(), FrameMouseActions.getY(),
-				getNextItemID());
+	public Item createDot()
+	{
+		Item dot = new Dot(DisplayController.getMouseX(), DisplayController.getMouseY(), getNextItemID());
 
 		Item template = getTemplate(_dotTemplate, ItemUtils.TAG_DOT_TEMPLATE);
 		float thickness = template.getThickness();
-		if (thickness > 0)
-			dot.setThickness(template.getThickness());
-		if (template.getLinePattern() != null)
-			dot.setLinePattern(template.getLinePattern());
+		if (thickness > 0) dot.setThickness(template.getThickness());
+		if (template.getLinePattern() != null) dot.setLinePattern(template.getLinePattern());
 		dot.setColor(template.getColor());
 		dot.setFillColor(template.getFillColor());
@@ -1665,5 +1741,6 @@
 	}
 
-	private Text getTemplate(Text defaultTemplate, int templateTag) {
+	private Text getTemplate(Text defaultTemplate, int templateTag)
+	{
 		Text t = null;
 
@@ -1677,7 +1754,6 @@
 
 		if (t == null) {
-			if (defaultTemplate == null) {
-				return null;
-			}
+			if (defaultTemplate == null) return null;
+			
 			t = defaultTemplate;
 		}
@@ -1685,4 +1761,5 @@
 		// If the item is linked apply any attribute pairs on the child frame
 		String link = t.getAbsoluteLink();
+		
 		// need to get link first because copy doesnt copy the link
 		t = t.copy();
@@ -1701,21 +1778,28 @@
 	}
 
-	public Text getItemTemplate(char firstChar) {
+	/**
+	 * TODO: Comment. cts16
+	 * TODO: Remove magic constants. cts16 
+	 */
+	public Text getItemTemplate(char firstChar)
+	{
 		switch (firstChar) {
-		case '@':
-			return getAnnotationTemplate();
-		case '/':
-		case '#':
-			return getCodeCommentTemplate();
-		default:
-			return getItemTemplate();
-		}
-	}
-
-	public Text createNewText() {
+			case '@':
+				return getAnnotationTemplate();
+			case '/':
+			case '#':
+				return getCodeCommentTemplate();
+			default:
+				return getItemTemplate();
+		}
+	}
+
+	public Text createNewText()
+	{
 		return createNewText("");
 	}
 
-	public Text addText(int x, int y, String text, String action) {
+	public Text addText(int x, int y, String text, String action)
+	{
 		Text t = createNewText(text);
 		t.setPosition(x, y);
@@ -1724,12 +1808,14 @@
 	}
 
-	public Item addText(int x, int y, String text, String action, String link) {
-		Item t = addText(x, y, text, action);
+	public Text addText(int x, int y, String text, String action, String link)
+	{
+		Text t = addText(x, y, text, action);
 		t.setLink(link);
 		return t;
 	}
 
-	public Item addDot(int x, int y) {
-		Item d = new Dot(x, y, getNextItemID());
+	public Dot addDot(int x, int y)
+	{
+		Dot d = new Dot(x, y, getNextItemID());
 		addItem(d);
 		return d;
@@ -1754,5 +1840,6 @@
 	 *            Color to fill the rectangle with
 	 */
-	public List<Item> addRectangle(int x, int y, int width, int height, float borderThickness, Color borderColor, Color fillColor) {
+	public List<Item> addRectangle(int x, int y, int width, int height, float borderThickness, Colour borderColor, Colour fillColor)
+	{
 		List<Item> rectComponents = new ArrayList<Item>();
 		Item[] corners = new Item[4];
@@ -1796,23 +1883,23 @@
 		List<Item> rect = new ArrayList<Item>(rectComponents);
 		this.addAllItems(rectComponents);
-		FrameMouseActions.anchor(rectComponents);
+		StandardGestureActions.anchor(rectComponents);
 		return rect;
-		// rectComponents.clear();
-	}
-
-	public boolean isSaved() {
+	}
+
+	public boolean isSaved()
+	{
 		return _saved;
 	}
 
-	public void setSaved() {
-		// System.out.println(getName() + " saved");
+	public void setSaved()
+	{
 		_saved = true;
 		_change = false;
 	}
 
-	public static boolean rubberbandingLine() {
-		return FreeItems.getInstance().size() == 2
-				&& (FreeItems.getInstance().get(0) instanceof Line || FreeItems
-						.getInstance().get(1) instanceof Line);
+	public static boolean rubberbandingLine()
+	{
+		return 	FreeItems.getInstance().size() == 2 &&
+				(FreeItems.getInstance().get(0) instanceof Line || FreeItems.getInstance().get(1) instanceof Line);
 	}
 
@@ -1825,7 +1912,7 @@
 	 * @return true if the item is a normal text item
 	 */
-	public boolean isNormalTextItem(Item it) {
-		if (it instanceof Text && it != getTitleItem() && it != _frameName
-				&& !((Text) it).isSpecialAnnotation()) {
+	public boolean isNormalTextItem(Item it)
+	{
+		if (it instanceof Text && it != getTitleItem() && it != _frameName && !((Text) it).isSpecialAnnotation()) {
 			return true;
 		}
@@ -1839,16 +1926,15 @@
 	 * @param index
 	 */
-	public boolean moveMouseToTextItem(int index) {
+	public boolean moveMouseToTextItem(int index)
+	{
 		List<Item> items = getItems();
 		int itemsFound = 0;
 		for (int i = 0; i < items.size(); i++) {
 			Item it = items.get(i);
-			if (isNormalTextItem(it))
-				itemsFound++;
+			if (isNormalTextItem(it)) itemsFound++;
 			if (itemsFound > index) {
-				DisplayIO.setCursorPosition(((Text) it)
-						.getParagraphEndPosition().x, it.getY());
-				DisplayIO.resetCursorOffset();
-				FrameGraphics.Repaint();
+				DisplayController.setCursorPosition(((Text) it).getParagraphEndPosition().x, it.getY());
+				DisplayController.resetCursorOffset();
+				DisplayController.requestRefresh(true);
 				return true;
 			}
@@ -1857,22 +1943,13 @@
 		return false;
 	}
-
-	/*
-	 * public boolean moveMouseToNextTextItem(int index) { List<Item> items =
-	 * getItems(); int itemsFound = 0; for (int i = 0; i < items.size(); i++) {
-	 * Item it = items.get(i); if ( isNormalTextItem(it)) itemsFound++; if
-	 * (itemsFound > index) {
-	 * DisplayIO.setCursorPosition(((Text)it).getEndParagraphPosition().x,
-	 * it.getY()); DisplayIO.resetCursorOffset(); FrameGraphics.Repaint();
-	 * return true; } }
-	 * 
-	 * return false; }
-	 */
 
 	/**
 	 * Searches for an annotation item called start to be used as the default
 	 * cursor location when TDFC occurs.
-	 */
-	public boolean moveMouseToDefaultLocation() {
+	 * 
+	 * TODO: Remove magic constants. cts16
+	 */
+	public boolean moveMouseToDefaultLocation()
+	{
 		List<Item> items = getItems();
 
@@ -1880,6 +1957,5 @@
 			if (it instanceof Text) {
 				Text t = (Text) it;
-				if (t.getText().toLowerCase().startsWith("@start")
-						|| t.getText().toLowerCase().equals("@start:")) {
+				if (t.getText().toLowerCase().startsWith("@start") || t.getText().toLowerCase().equals("@start:")) {
 					// Used to allow users the option of putting an initial
 					// bullet after the @start
@@ -1888,12 +1964,13 @@
 					t.setText("");
 
-					if (t.getText().equals(""))
-						DisplayIO.getCurrentFrame().removeItem(t);
-					if (!FreeItems.itemsAttachedToCursor()) {
-						DisplayIO.setCursorPosition(((Text) it)
-								.getParagraphEndPosition());
-						DisplayIO.resetCursorOffset();
+					if (t.getText().equals("")) DisplayController.getCurrentFrame().removeItem(t);
+					
+					if (!FreeItems.hasItemsAttachedToCursor()) {
+						DisplayController.setCursorPosition(((Text) it).getParagraphEndPosition());
+						DisplayController.resetCursorOffset();
 					}
-					FrameGraphics.Repaint();
+					
+					DisplayController.requestRefresh(true);
+					
 					return true;
 				}
@@ -1911,5 +1988,6 @@
 	 *         name of the frame if the tag isnt on the frame.
 	 */
-	public String getExportFileName() {
+	public String getExportFileName()
+	{
 		String fileName = getExportFileTagValue();
 
@@ -1925,10 +2003,11 @@
 	}
 
-	public void toggleBackgroundColor() {
-		setBackgroundColor(ColorUtils.getNextColor(_background,
-				TemplateSettings.BackgroundColorWheel.get(), null));
-	}
-
-	public void setName(String frameset, int i) {
+	public void toggleBackgroundColor()
+	{
+		setBackgroundColor(ColorUtils.getNextColor(_background, TemplateSettings.BackgroundColorWheel.get(), null));
+	}
+
+	public void setName(String frameset, int i)
+	{
 		setFrameset(frameset);
 		setFrameNumber(i);
@@ -1940,7 +2019,7 @@
 	 * 
 	 */
-	public void refreshItemPermissions(UserAppliedPermission maxPermission) {
-		if(_frameName == null)
-			return;
+	public void refreshItemPermissions(UserAppliedPermission maxPermission)
+	{
+		if(_frameName == null) return;
 		
 		UserAppliedPermission permission = UserAppliedPermission.min(maxPermission, getUserAppliedPermission());
@@ -1948,17 +2027,17 @@
 		switch (permission) {
 		case none:
-			_frameName.setBackgroundColor(new Color(255, 220, 220));
+			_frameName.setBackgroundColor(FRAME_NAME_BACKGROUND_COLOUR_FOR_PERMISSION_NONE);
 			break;
 		case followLinks:
-			_frameName.setBackgroundColor(new Color(255, 230, 135));
+			_frameName.setBackgroundColor(FRAME_NAME_BACKGROUND_COLOUR_FOR_PERMISSION_FOLLOW_LINKS);
 			break;
 		case copy:
-			_frameName.setBackgroundColor(new Color(255, 255, 155));
+			_frameName.setBackgroundColor(FRAME_NAME_BACKGROUND_COLOUR_FOR_PERMISSION_COPY);
 			break;
 		case createFrames:
-			_frameName.setBackgroundColor(new Color(220, 255, 220));
+			_frameName.setBackgroundColor(FRAME_NAME_BACKGROUND_COLOUR_FOR_PERMISSION_CREATE_FRAMES);
 			break;
 		case full:
-			_frameName.setBackgroundColor(null);
+			_frameName.setBackgroundColor(FRAME_NAME_BACKGROUND_COLOUR_FOR_PERMISSION_FULL);
 			break;
 		default:
@@ -1975,20 +2054,18 @@
 	}
 
-	public boolean isTestFrame() {
+	public boolean isTestFrame()
+	{
 		Text title = getTitleItem();
-		if (title == null)
-			return false;
+		if (title == null) return false;
 		String action = title.getFirstAction();
-		if (action == null)
-			return false;
+		if (action == null) return false;
 		action = action.toLowerCase();
-		return action.startsWith(Simple.RUN_FRAME_ACTION)
-				|| action.startsWith(Simple.DEBUG_FRAME_ACTION);
-	}
-
-	public void setActiveTime(String activeTime) {
+		return action.startsWith(Simple.RUN_FRAME_ACTION) || action.startsWith(Simple.DEBUG_FRAME_ACTION);
+	}
+
+	public void setActiveTime(String activeTime)
+	{
 		try {
-			_activeTime = new Time(Time.valueOf(activeTime).getTime() + 12 * 60
-					* 60 * 1000);
+			_activeTime = new Time(Time.valueOf(activeTime).getTime() + 12 * 60 * 60 * 1000);
 		} catch (Exception e) {
 			_activeTime = new Time(0);
@@ -1996,16 +2073,18 @@
 	}
 
-	public void setActiveTime(Time activeTime) {
+	public void setActiveTime(Time activeTime)
+	{
 		_activeTime = activeTime;
 	}
 
-	public void setDarkTime(Time darkTime) {
+	public void setDarkTime(Time darkTime)
+	{
 		_darkTime = darkTime;
 	}
 
-	public void setDarkTime(String darkTime) {
+	public void setDarkTime(String darkTime)
+	{
 		try {
-			_darkTime = new Time(Time.valueOf(darkTime).getTime() + 12 * 60
-					* 60 * 1000);
+			_darkTime = new Time(Time.valueOf(darkTime).getTime() + 12 * 60 * 60 * 1000);
 		} catch (Exception e) {
 			_darkTime = new Time(0);
@@ -2018,8 +2097,9 @@
 	 * @return the backup frame for this frame
 	 */
-	public Frame getBackupFrame() {
+	public Frame getBackupFrame()
+	{
 		Text backupTag = _annotations.get("old");
-		if (backupTag == null)
-			return null;
+		if (backupTag == null) return null;
+		
 		// TODO want another way to deal with updating of annotations items
 		// without F12 refresh
@@ -2031,8 +2111,8 @@
 			return getBackupFrame();
 		}
+		
 		// Now return the name of the backed up frame
 		String link = backupTag.getAbsoluteLink();
-		if (link == null || link.equalsIgnoreCase(getName()))
-			return null;
+		if (link == null || link.equalsIgnoreCase(getName())) return null;
 
 		Frame backup = FrameIO.LoadFrame(link);
@@ -2040,9 +2120,11 @@
 	}
 
-	public Time getDarkTime() {
+	public Time getDarkTime()
+	{
 		return _darkTime;
 	}
 
-	public Time getActiveTime() {
+	public Time getActiveTime()
+	{
 		return _activeTime;
 	}
@@ -2054,13 +2136,16 @@
 	 * @return the number of frames in the backed up comet
 	 */
-	public int getCometLength() {
+	public int getCometLength()
+	{
 		Frame backup = getBackupFrame();
 		return 1 + (backup == null ? 0 : backup.getCometLength());
 	}
 
-	public void addAnnotation(Text item) {
+	public void addAnnotation(Text item)
+	{
 		if (_annotations == null) {
 			_annotations = new HashMap<String, Text>();
 		}
+		
 		// Check if this item has already been processed
 		String[] tokens = item.getProcessedText();
@@ -2074,4 +2159,5 @@
 		String text = item.getText().trim();
 		assert (text.charAt(0) == '@');
+		
 		// Ignore annotations with spaces after the tag symbol
 		if (text.length() < 2 || !Character.isLetter(text.charAt(1))) {
@@ -2079,4 +2165,5 @@
 			return;
 		}
+		
 		// The separator char must come before the first non letter otherwise we
 		// ignore the annotation item
@@ -2101,4 +2188,5 @@
 			}
 		}
+		
 		// If it was nothing but letters and digits save the tag
 		String lowerCaseText = text.substring(1).toLowerCase();
@@ -2107,7 +2195,8 @@
 	}
 
-	public boolean hasAnnotation(String annotation) {
-		if (_annotations == null)
-			refreshAnnotationList();
+	public boolean hasAnnotation(String annotation)
+	{
+		if (_annotations == null) refreshAnnotationList();
+		
 		return _annotations.containsKey(annotation.toLowerCase());
 	}
@@ -2121,35 +2210,36 @@
 	 *         is not on the frame or has no value.
 	 */
-	public String getAnnotationValue(String annotation) {
-		if (_annotations == null)
-			refreshAnnotationList();
+	public String getAnnotationValue(String annotation)
+	{
+		if (_annotations == null) refreshAnnotationList();
 
 		Text text = _annotations.get(annotation.toLowerCase());
-		if (text == null)
-			return null;
+		if (text == null) return null;
 
 		String[] tokens = text.getProcessedText();
-		if (tokens != null && tokens.length > 1)
-			return tokens[1];
+		
+		if (tokens != null && tokens.length > 1) return tokens[1];
+		
 		return null;
 	}
 
-	Map<String, Text> _annotations = null;
-
-	private Collection<FrameObserver> _observers = new HashSet<FrameObserver>();
-
-	public void clearAnnotations() {
+	public void clearAnnotations()
+	{
 		_annotations = null;
 	}
 
-	public List<Item> getVisibleItems() {
+	public List<Item> getVisibleItems()
+	{
 		return getItems(true);
 	}
 
-	private void refreshAnnotationList() {
-		if (_annotations == null)
+	private void refreshAnnotationList()
+	{
+		if (_annotations == null) {
 			_annotations = new HashMap<String, Text>();
-		else
+		} else {
 			_annotations.clear();
+		}
+		
 		for (Text text : getTextItems()) {
 			if (text.isAnnotation()) {
@@ -2159,8 +2249,10 @@
 	}
 
-	public Collection<Text> getAnnotationItems() {
+	public Collection<Text> getAnnotationItems()
+	{
 		if (_annotations == null) {
 			refreshAnnotationList();
 		}
+		
 		return _annotations.values();
 	}
@@ -2171,6 +2263,6 @@
 	 * @return the list of items to be saved to a text file
 	 */
-	public List<Item> getItemsToSave() {
-
+	public List<Item> getItemsToSave()
+	{
 		if (!_sorted) {
 			Collections.sort(_body);
@@ -2179,18 +2271,15 @@
 
 		// iWidgets are handled specially since 8 items are written as one
-		Collection<InteractiveWidget> seenWidgets = new LinkedHashSet<InteractiveWidget>();
+		Collection<Widget> seenWidgets = new LinkedHashSet<Widget>();
 
 		List<Item> toSave = new ArrayList<Item>();
 
 		for (Item i : _body) {
-			if (i == null || i.dontSave()) {
-				continue;
-			}
+			if (i == null || i.dontSave()) continue;
 
 			// Ensure only one of the WidgetCorners represent a single widget
 			if (i instanceof WidgetCorner) {
-				InteractiveWidget iw = ((WidgetCorner) i).getWidgetSource();
-				if (seenWidgets.contains(iw))
-					continue;
+				Widget iw = ((WidgetCorner) i).getWidgetSource();
+				if (seenWidgets.contains(iw)) continue;
 				seenWidgets.add(iw);
 				toSave.add(iw.getSource());
@@ -2198,6 +2287,6 @@
 				XRayable x = (XRayable) i;
 				toSave.addAll(x.getItemsToSave());
-			}// Circle centers are items with attached enclosures
-			else if (i.hasEnclosures()) {
+			// Circle centers are items with attached enclosures
+			} else if (i.hasEnclosures()) {
 				continue;
 			} else {
@@ -2213,5 +2302,6 @@
 	}
 
-	public Collection<Item> getOverlayItems() {
+	public Collection<Item> getOverlayItems()
+	{
 		return _overlayItems;
 	}
@@ -2223,9 +2313,11 @@
 	 * @return
 	 */
-	public boolean hasOverlay(Frame frame) {
+	public boolean hasOverlay(Frame frame)
+	{
 		return _overlays.containsValue(frame);
 	}
 
-	public Collection<Item> getAllItems() {
+	public Collection<Item> getAllItems()
+	{
 		Collection<Item> allItems = new LinkedHashSet<Item>(_body);
 		allItems.addAll(_overlayItems);
@@ -2234,5 +2326,6 @@
 	}
 
-	public Collection<Item> getVectorItems() {
+	public Collection<Item> getVectorItems()
+	{
 		Collection<Item> vectorItems = new LinkedHashSet<Item>(_vectorItems);
 		vectorItems.addAll(getNonAnnotationItems(false));
@@ -2245,6 +2338,8 @@
 	 * @return
 	 */
-	public Collection<Text> getTextItems() {
+	public Collection<Text> getTextItems()
+	{
 		Collection<Text> textItems = new ArrayList<Text>();
+		
 		for (Item i : getItems(true)) {
 			// only add up normal body text items
@@ -2253,16 +2348,17 @@
 			}
 		}
+		
 		return textItems;
 	}
 
-	public Text getAnnotation(String annotation) {
-		if (_annotations == null)
-			refreshAnnotationList();
+	public Text getAnnotation(String annotation)
+	{
+		if (_annotations == null) refreshAnnotationList();
 
 		return _annotations.get(annotation.toLowerCase());
 	}
 
-	public void recalculate() {
-
+	public void recalculate()
+	{
 		for (Item i : getItems()) {
 			if (i.hasFormula() && !i.isAnnotation()) {
@@ -2272,22 +2368,28 @@
 	}
 
-	public void removeObserver(FrameObserver observer) {
+	public void removeObserver(FrameObserver observer)
+	{
 		_observers.remove(observer);
 	}
 
-	public void addObserver(FrameObserver observer) {
+	public void addObserver(FrameObserver observer)
+	{
 		_observers.add(observer);
 	}
 
-	public void clearObservers() {
+	public void clearObservers()
+	{
 		for (FrameObserver fl : _observers) {
 			fl.removeSubject(this);
 		}
+		
 		// The frame listener will call the frames removeListener method
 		assert (_observers.size() == 0);
 	}
 
-	public Collection<Text> getNonAnnotationText(boolean removeTitle) {
+	public Collection<Text> getNonAnnotationText(boolean removeTitle)
+	{
 		Collection<Text> items = new LinkedHashSet<Text>();
+		
 		for (Item i : getItems(true)) {
 			// only add up normal body text items
@@ -2296,15 +2398,20 @@
 			}
 		}
+		
 		if (removeTitle) {
 			items.remove(getTitleItem());
 		}
+		
 		return items;
 	}
 
-	public void dispose() {
+	public void dispose()
+	{
 		clearObservers();
+		
 		for (Item i : _body) {
 			i.dispose();
 		}
+		
 		_frameName.dispose();
 		_body = null;
